



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>最简单的视音频播放示例2：GDI播放YUV, RGB</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">最简单的视音频播放示例2：GDI播放YUV, RGB</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 15:06:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前一篇文章对&ldquo;Simplest Media Play&rdquo;工程作了概括性介绍。后续几篇文章打算详细介绍每个子工程中的几种技术。在记录Direct3D，OpenGL这两种相对复杂的技术之前，打算先记录一种和它们属于同一层面的的简单的技术&mdash;&mdash;GDI作为热身。</p>
<h2>GDI简介</h2>
<p>下面这段文字摘自维基百科：</p>
<p>图形设备接口（Graphics Device Interface或Graphical Device Interface，缩写GDI），是微软公司视窗操作系统（Microsoft Windows）的三大核心部件（另外两个是kernel、user）之一。GDI是微软视窗系统表征图形对象及将其传送给诸如显示器、打印机之类输出设备的标准。其他系统也有类似GDI的东西，比如Macintosh的Quartz（传统的QuickDraw），和GTK的GDK/Xlib。<br />	GDI用来完成一些和绘制有关的工作，像直线或曲线的绘制，文字渲染，调色板控制。它最大的好处是它有可以直接访问硬件设备的能力。通过GDI可以非常容易的在不同类型的设备上绘制图形，像显示屏和打印机或类似的显示设备。这些能力是微软Windows系统&ldquo;所见即所得&rdquo;程序的核心。<br />	简单的不需要快速图形渲染的游戏可能会用到GDI。但是GDI对一些高级的动画制作无能为力，它缺少显卡中帧的概念，还缺少3D图形硬件光栅化的支持等等。现代的游戏通常使用DirectX和OpenGL而不是GDI，因为这些技术能更好的让程序员利用硬件的特性来加速图形图像的显示。<br />	下面这张图可以很好的表现GDI（以及Direct3D）在系统中的位置。可以看出它们位于应用程序和硬件之间，和Direct3D属于同一类型的东西。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019194519318?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>我自己在之前做的码流分析程序《VideoEye》中的&ldquo;单帧详细分析&rdquo;模块中曾经大量使用了GDI，因为那个功能需要在窗口中绘制帧图像，量化参数，宏块类型，运动矢量等参数。因此对GDI这部分的函数还算熟悉。例如下图是当时画出的&ldquo;量化参数&rdquo;，&ldquo;宏块划分&rdquo;和&ldquo;运动矢量&rdquo;分析结果。图中的背景图像，数字，直线都是通过GDI画上去的。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019194605962?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019194614574?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019194618084?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<h2>视频像素数据</h2>
<p>视频显示的输入数据一般情况下是非压缩的RGB/YUV数据。像H.264这些压缩码流是不能用于显示的。非压缩的RGB/YUV数据在我们电脑里并不常见，因为它的体积实在是太大了。几秒钟的RGB/YUV数据就有几十MB甚至上百MB大。举个例子，5秒分辨率为1280x720，格式为RGB24的视频数据体积（按照每秒25帧计算）为：</p>
<p>1280*720*3*25*5=345600000B=345.6MB</p>
<p>我们日常生活中比较常见的存储非压缩的RGB像素数据的格式就是BMP。它的文件体（除去文件头）中存储的是RGB数据。很容易发现，BMP文件明显大于JPEG等压缩格式的文件。</p>
<p>本文记录的例子的使用的是纯像素数据，和BMP这种封装过的RGB数据最大的不同在于没有文件头，需要使用特定的播放器，设定参数之后才能正确播放。</p>
<p>PS：纯像素数据播放器推荐以下两个：</p>
<p>YUV Player Deluxe： 只能播放YUV格式，但是确实很好使。</p>
<p>Vooya： 除了支持YUV之外，还支持各种各样的RGB数据，更加强大。</p>
<h2>视频显示的要点</h2>
<p>用GDI显示像素数据是极其简单的，难度远远低于Direct3D和OpenGL。可以分成两步：</p>
<p>1.	构造一张BMP。</p>
<p>（1）	构造文件头<br />（2）	读取像素数据</p>
<p>2.	调用函数画上去。</p>
<p>下面分步说明：</p>
<h3>1.	构造一张BMP</h3>
<h4>（1）	构造文件头</h4>
<p>构造BMP需要用到结构体BITMAPINFO，该结构体主要用于存储BMP文件头信息：</p>
<div>
<ol><li>//BMP&nbsp;Header</li>
<li>BITMAPINFO&nbsp;m_bmphdr={0};</li>
<li>DWORD&nbsp;dwBmpHdr&nbsp;=&nbsp;sizeof(BITMAPINFO);</li>
<li>m_bmphdr.bmiHeader.biBitCount&nbsp;=&nbsp;24;</li>
<li>m_bmphdr.bmiHeader.biClrImportant&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biSize&nbsp;=&nbsp;dwBmpHdr;</li>
<li>m_bmphdr.bmiHeader.biSizeImage&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biWidth&nbsp;=&nbsp;pixel_w;</li>
<li>//注意BMP在y方向是反着存储的，一次必须设置一个负值，才能使图像正着显示出来</li>
<li>m_bmphdr.bmiHeader.biHeight&nbsp;=&nbsp;-pixel_h;</li>
<li>m_bmphdr.bmiHeader.biXPelsPerMeter&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biYPelsPerMeter&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biClrUsed&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biPlanes&nbsp;=&nbsp;1;</li>
<li>m_bmphdr.bmiHeader.biCompression&nbsp;=&nbsp;BI_RGB;</li></ol>
</div>
<p>从构造BMP这一步我们可以得知：像素格式必须转换为RGB（即不能是YUV）才能使用GDI画上去。因为BMP存储像素是RGB格式的。</p>
<h4>（2）	读取像素数据</h4>
<p><strong>大端和小端</strong></p>
<p>读取像素数据的时候，又涉及到一个知识点：大端模式和小端模式。</p>
<p>假使我们直接读取rgb24格式的一帧数据（在硬盘中的存储方式为R1|G1|B1，R2|G2|B2，R3|G3|B3），然后显示出来，会发现所有的人物都变成了&ldquo;阿凡达&rdquo;（忽然感觉这个比喻还挺形象的）：就是人的皮肤都变成了蓝色了。导致这个的原因实际上是系统把&ldquo;R&rdquo;当成&ldquo;B&rdquo;，而把&ldquo;B&rdquo;当成&ldquo;R&rdquo;的结果。因此，如果我们如果把&ldquo;R&rdquo;和&ldquo;B&rdquo;的顺序调换一下的话（&ldquo;G&rdquo;保持不变），显示就正常了。<br />	针对上述现象，我们可以得知BMP的RGB24格式的数据实际上是B1|G1|R1，B2|G2|R2这样的顺序存储的。那么问题来了，为什么会这么存储呢？这么存储的话，岂不是把像素格式起名字叫&ldquo;BGR24&rdquo;更合适？下面就详细分析一下这个问题。<br />	首先来看一下&ldquo;RGB24&rdquo;这种名称的起名规则。它们是按照&ldquo;高字节-&gt;低字节&rdquo;的方式起名的。即高字节存&ldquo;R&rdquo;，低字节存&ldquo;B&rdquo;。在系统中，一个像素点的像素值（RGB24则是包含R，G，B三个8Byte的数据；RGBA则包含R，G，B，A四个8Byte的数据）被认为是一个&ldquo;颜色&rdquo;变量（官方有正规的结构体定义：tagRGBTRIPLE，tagRGBQUAD。也是类似于int，char这样的变量）。这种长度超过1Byte的变量（int的长度也超过了1Byte）存储的时候就涉及到一个的问题：变量的低字节应该保存在内存的高地址还是低地址？<br />对于上述问题，有两种存储方法：<br />		大端模式（Big Endian），是指数据的低字节（注意是整个字节）保存在内存的高地址中，而数据的高字节，保存在内存的低地址中。其实这是一个更符合人类习惯的存储方式。<br />	小端模式（Little Endian），是指数据的低字节保存在内存的低地址中，而数据的高字节保存在内存的高地址中。</p>
<p>大部分用户的操作系统（如Windows，FreeBsd，Linux）是Little Endian的。少部分，如MAC OS是Big Endian 的。此外，网络字节序是Big Endian的。BMP文件的存储规定是Little Endian。因此，例如对于3Byte的RGB24变量，其低字节为&ldquo;B&rdquo;，而低字节应该保存在内存的低地址中，因此应该保存在最&ldquo;前面&rdquo;。所以RGB24格式的像素数据，在BMP文件中的存储方式是B1|G1|R1，B2|G2|R2&hellip;</p>
<p>也可以看一下官方的定义：</p>
<div>
<ol><li>typedef&nbsp;struct&nbsp;tagRGBTRIPLE&nbsp;{</li>
<li>BYTE&nbsp;rgbtBlue;&nbsp;&nbsp;//&nbsp;蓝色分量</li>
<li>BYTE&nbsp;rgbtGreen;&nbsp;//&nbsp;绿色分量</li>
<li>BYTE&nbsp;rgbtRed;&nbsp;&nbsp;&nbsp;//&nbsp;红色分量</li>
<li>}&nbsp;RGBTRIPLE;</li>
<li>typedef&nbsp;struct&nbsp;tagRGBQUAD&nbsp;{</li>
<li>BYTE&nbsp;rgbBlue;&nbsp;&nbsp;&nbsp;//&nbsp;蓝色分量</li>
<li>BYTE&nbsp;rgbGreen;&nbsp;&nbsp;//&nbsp;绿色分量</li>
<li>BYTE&nbsp;rgbRed;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;红色分量</li>
<li>BYTE&nbsp;rgbReserved;&nbsp;//&nbsp;保留字节</li>
<li>}&nbsp;RGBQUAD。</li></ol>
</div>
<p><strong>大端和小端的转换</strong></p>
<p>大端和小端的转换其实非常简单，只要交换它们的字节就可以了。下面代码列出了24bit（3字节）的数据的大端和小端之间的转换方法。</p>
<div>
<ol><li>//change&nbsp;endian&nbsp;of&nbsp;a&nbsp;pixel&nbsp;(24bit)</li>
<li>void&nbsp;CHANGE_ENDIAN_24(unsigned&nbsp;char&nbsp;*data){</li>
<li>char&nbsp;temp2=data[2];</li>
<li>data[2]=data[0];</li>
<li>data[0]=temp2;</li>
<li>}</li></ol>
</div>
<p>下面代码列出了32bit（4字节）的数据的大端和小端之间转换的方法。</p>
<div>
<ol><li>//change&nbsp;endian&nbsp;of&nbsp;a&nbsp;pixel&nbsp;(32bit)</li>
<li>void&nbsp;CHANGE_ENDIAN_32(unsigned&nbsp;char&nbsp;*data){</li>
<li>char&nbsp;temp3,temp2;</li>
<li>temp3=data[3];</li>
<li>temp2=data[2];</li>
<li>data[3]=data[0];</li>
<li>data[2]=data[1];</li>
<li>data[0]=temp3;</li>
<li>data[1]=temp2;</li>
<li>}</li></ol>
</div>
<p>通过调用上述两个函数，可以实现整张RGB（24bit或者32bit）图片的大端与小端之间的转换。</p>
<div>
<ol><li>//Change&nbsp;endian&nbsp;of&nbsp;a&nbsp;picture</li>
<li>void&nbsp;CHANGE_ENDIAN_PIC(unsigned&nbsp;char&nbsp;*image,int&nbsp;w,int&nbsp;h,int&nbsp;bpp){</li>
<li>unsigned&nbsp;char&nbsp;*pixeldata=NULL;</li>
<li>for(int&nbsp;i&nbsp;=0;i&lt;h;i++)</li>
<li>for(int&nbsp;j=0;j&lt;w;j++){</li>
<li>pixeldata=image+(i*w+j)*bpp/8;</li>
<li>if(bpp==32){</li>
<li>CHANGE_ENDIAN_32(pixeldata);</li>
<li>}else&nbsp;if(bpp==24){</li>
<li>CHANGE_ENDIAN_24(pixeldata);</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>综上所述，需要把输入的rgb24格式的数据（在硬盘中的存储方式为R1|G1|B1，R2|G2|B2，R3|G3|B3），经过大端和小端的转换，然后调用显示的函数，才能正确的显示出来。<br />PS：当然，如果输入是bgr24格式的数据（在硬盘中的存储方式为B1|G1|R1，B2|G2|R2，B3|G3|R3）的话，是可以不用转换直接正确的显示的。但是要了解到并不是BMP硬性规定了B|G|R这样的存储顺序。其中是有原因的。</p>
<p><strong>显示YUV420P数据</strong></p>
<p>如果输入像素格式是YUV420P的话，需要使用函数CONVERT_YUV420PtoRGB24()先将YUV420P格式数据转换为rgb24的数据。需要注意的是转换完的数据同样要把&ldquo;大端&rdquo;转换成&ldquo;小端&rdquo;才能正确的在屏幕上显示。CONVERT_YUV420PtoRGB24()代码要稍微复杂些，如下所示。其中提供了两套公式用于YUV420P向rgb24转换，效果略微有些区别，可以自己改改试试。</p>
<div>
<ol><li>inline&nbsp;byte&nbsp;CONVERT_ADJUST(double&nbsp;tmp)</li>
<li>{</li>
<li>return&nbsp;(byte)((tmp&nbsp;&gt;=&nbsp;0&nbsp;&amp;&amp;&nbsp;tmp&nbsp;&lt;=&nbsp;255)?tmp:(tmp&nbsp;&lt;&nbsp;0&nbsp;?&nbsp;0&nbsp;:&nbsp;255));</li>
<li>}</li>
<li>//YUV420P&nbsp;to&nbsp;RGB24</li>
<li>void&nbsp;CONVERT_YUV420PtoRGB24(unsigned&nbsp;char*&nbsp;yuv_src,unsigned&nbsp;char*&nbsp;rgb_dst,int&nbsp;nWidth,int&nbsp;nHeight)</li>
<li>{</li>
<li>unsigned&nbsp;char&nbsp;*tmpbuf=(unsigned&nbsp;char&nbsp;*)malloc(nWidth*nHeight*3);</li>
<li>unsigned&nbsp;char&nbsp;Y,U,V,R,G,B;</li>
<li>unsigned&nbsp;char*&nbsp;y_planar,*u_planar,*v_planar;</li>
<li>int&nbsp;rgb_width&nbsp;,&nbsp;u_width;</li>
<li>rgb_width&nbsp;=&nbsp;nWidth&nbsp;*&nbsp;3;</li>
<li>u_width&nbsp;=&nbsp;(nWidth&nbsp;&gt;&gt;&nbsp;1);</li>
<li>int&nbsp;ypSize&nbsp;=&nbsp;nWidth&nbsp;*&nbsp;nHeight;</li>
<li>int&nbsp;upSize&nbsp;=&nbsp;(ypSize&gt;&gt;2);</li>
<li>int&nbsp;offSet&nbsp;=&nbsp;0;</li>
<li>y_planar&nbsp;=&nbsp;yuv_src;</li>
<li>u_planar&nbsp;=&nbsp;yuv_src&nbsp;+&nbsp;ypSize;</li>
<li>v_planar&nbsp;=&nbsp;u_planar&nbsp;+&nbsp;upSize;</li>
<li>for(int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;nHeight;&nbsp;i++)</li>
<li>{</li>
<li>for(int&nbsp;j&nbsp;=&nbsp;0;&nbsp;j&nbsp;&lt;&nbsp;nWidth;&nbsp;j&nbsp;++)</li>
<li>{</li>
<li>//&nbsp;Get&nbsp;the&nbsp;Y&nbsp;value&nbsp;from&nbsp;the&nbsp;y&nbsp;planar</li>
<li>Y&nbsp;=&nbsp;*(y_planar&nbsp;+&nbsp;nWidth&nbsp;*&nbsp;i&nbsp;+&nbsp;j);</li>
<li>//&nbsp;Get&nbsp;the&nbsp;V&nbsp;value&nbsp;from&nbsp;the&nbsp;u&nbsp;planar</li>
<li>offSet&nbsp;=&nbsp;(i&gt;&gt;1)&nbsp;*&nbsp;(u_width)&nbsp;+&nbsp;(j&gt;&gt;1);</li>
<li>V&nbsp;=&nbsp;*(u_planar&nbsp;+&nbsp;offSet);</li>
<li>//&nbsp;Get&nbsp;the&nbsp;U&nbsp;value&nbsp;from&nbsp;the&nbsp;v&nbsp;planar</li>
<li>U&nbsp;=&nbsp;*(v_planar&nbsp;+&nbsp;offSet);</li>
<li>//&nbsp;Cacular&nbsp;the&nbsp;R,G,B&nbsp;values</li>
<li>//&nbsp;Method&nbsp;1</li>
<li>R&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;+&nbsp;(1.4075&nbsp;*&nbsp;(V&nbsp;-&nbsp;128))));</li>
<li>G&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;-&nbsp;(0.3455&nbsp;*&nbsp;(U&nbsp;-&nbsp;128)&nbsp;-&nbsp;0.7169&nbsp;*&nbsp;(V&nbsp;-&nbsp;128))));</li>
<li>B&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;+&nbsp;(1.7790&nbsp;*&nbsp;(U&nbsp;-&nbsp;128))));</li>
<li>/*</li>
<li>//&nbsp;The&nbsp;following&nbsp;formulas&nbsp;are&nbsp;from&nbsp;MicroSoft'&nbsp;MSDN</li>
<li>int&nbsp;C,D,E;</li>
<li>//&nbsp;Method&nbsp;2</li>
<li>C&nbsp;=&nbsp;Y&nbsp;-&nbsp;16;</li>
<li>D&nbsp;=&nbsp;U&nbsp;-&nbsp;128;</li>
<li>E&nbsp;=&nbsp;V&nbsp;-&nbsp;128;</li>
<li>R&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;+&nbsp;409&nbsp;*&nbsp;E&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>G&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;-&nbsp;100&nbsp;*&nbsp;D&nbsp;-&nbsp;208&nbsp;*&nbsp;E&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>B&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;+&nbsp;516&nbsp;*&nbsp;D&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>R&nbsp;=&nbsp;((R&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(R&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>G&nbsp;=&nbsp;((G&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(G&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>B&nbsp;=&nbsp;((B&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(B&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>*/</li>
<li>offSet&nbsp;=&nbsp;rgb_width&nbsp;*&nbsp;i&nbsp;+&nbsp;j&nbsp;*&nbsp;3;</li>
<li>rgb_dst[offSet]&nbsp;=&nbsp;B;</li>
<li>rgb_dst[offSet&nbsp;+&nbsp;1]&nbsp;=&nbsp;G;</li>
<li>rgb_dst[offSet&nbsp;+&nbsp;2]&nbsp;=&nbsp;R;</li>
<li>}</li>
<li>}</li>
<li>free(tmpbuf);</li>
<li>}</li></ol>
</div>
<h3>2.	调用函数画上去。</h3>
<p>最关键的绘图函数只有一个：StretchDIBits()。该函数将矩形区域内像素数据拷贝到指定的目标矩形中。如果目标矩形与源矩形大小不一样，那么函数将会对颜色数据的行和列进行拉伸或压缩，以与目标矩形匹配。</p>
<p>StretchDIBits()这个函数的参数实在是太多了一共12个。它的原型如下：</p>
<div>
<ol><li>int&nbsp;StretchDIBits(HDC&nbsp;hdc,&nbsp;int&nbsp;XDest&nbsp;,&nbsp;int&nbsp;YDest&nbsp;,&nbsp;int&nbsp;nDestWidth,&nbsp;int&nbsp;nDestHeight,&nbsp;int&nbsp;XSrc,&nbsp;int&nbsp;Ysrc,&nbsp;int&nbsp;nSrcWidth,&nbsp;int&nbsp;nSrcHeight,&nbsp;CONST&nbsp;VOID&nbsp;*lpBits,&nbsp;CONST&nbsp;BITMAPINFO&nbsp;*&nbsp;lpBitsInfo,&nbsp;UINT&nbsp;iUsage,&nbsp;DWORD&nbsp;dwRop);</li></ol>
</div>
<p>它的参数的意义：</p>
<blockquote><p>hdc：指向目标设备环境的句柄。<br />XDest：指定目标矩形左上角位置的X轴坐标，按逻辑单位来表示坐标。<br />YDest：指定目标矩形左上角的Y轴坐标，按逻辑单位表示坐标。<br />nDestWidth：指定目标矩形的宽度。<br />nDestHeight：指定目标矩形的高度。<br />XSrc：指定DIB中源矩形（左上角）的X轴坐标，坐标以像素点表示。<br />YSrc：指定DIB中源矩形（左上角）的Y轴坐标，坐标以像素点表示。<br />nSrcWidth：按像素点指定DIB中源矩形的宽度。<br />nSrcHeight：按像素点指定DIB中源矩形的高度。<br />lpBits：指向DIB位的指针，这些位的值按字节类型数组存储，有关更多的信息，参考下面的备注一节。<br />lpBitsInfo：指向BITMAPINFO结构的指针，该结构包含有关DIB方面的信息。<br />iUsage：表示是否提供了BITMAPINFO结构中的成员bmiColors，如果提供了，那么该bmiColors是否包含了明确的RGB值或索引。参数iUsage必须取下列值，这些值的含义如下：<br />DIB_PAL_COLORS：表示该数组包含对源设备环境的逻辑调色板进行索引的16位索引值。<br />DIB_RGB_COLORS：表示该颜色表包含原义的RGB值。<br />dwRop：指定源像素点、目标设备环境的当前刷子和目标像素点是如何组合形成新的图像。</p>
<p>返回值：如果函数执行成功，那么返回值是拷贝的扫描线数目，如果函数执行失败，那么返回值是GDI_ERROR。</p></blockquote>
<p>别看StretchDIBits()那个函数看似很复杂，实际上我们只需要指定下面4个信息：源矩形，目标矩形，BMP文件头，BMP文件数据。参考代码如下。</p>
<div>
<ol><li>//将RGB数据画在控件上</li>
<li>int&nbsp;nResult&nbsp;=&nbsp;StretchDIBits(hdc,</li>
<li>0,0,</li>
<li>screen_w,screen_h,</li>
<li>0,&nbsp;0,</li>
<li>pixel_w,&nbsp;pixel_h,</li>
<li>raw_buffer,</li>
<li>&amp;m_bmphdr,</li>
<li>DIB_RGB_COLORS,</li>
<li>SRCCOPY);</li></ol>
</div>
<p>最后补充一句，在画图之前首先要获取目标窗口的HDC（Handle of Device Context，设备上下文句柄）。在画图完成之后要释放HDC。</p>
<div>
<ol><li>HDC&nbsp;hdc=GetDC(hwnd);</li>
<li>//画图&hellip;</li>
<li>ReleaseDC(hwnd,hdc);</li></ol>
</div>
<h3>其他要点</h3>
<p>本程序使用的是Win32的API创建的窗口。但注意这个并不是MFC应用程序的窗口。MFC代码量太大，并不适宜用来做教程。因此使用Win32的API创建窗口。程序的入口函数是WinMain()，其中调用了CreateWindow()创建了显示视频的窗口。此外，程序中的消息循环使用的是PeekMessage()而不是GetMessage()。GetMessage()获取消息后，将消息从系统中移除，当系统无消息时，会等待下一条消息，是阻塞函数。而函数PeekMesssge()是以查看的方式从系统中获取消息，可以不将消息从系统中移除（相当于&ldquo;偷看&rdquo;消息），是非阻塞函数；当系统无消息时，返回FALSE，继续执行后续代码。使用PeekMessage()的好处是可以保证每隔40ms可以显示下一帧画面。</p>
<h2>源代码</h2>
<p>下面贴上GDI显示YUV/RGB的完整源代码</p>
<div>
<ol><li>/**</li>
<li>*&nbsp;最简单的GDI播放视频的例子（GDI播放RGB/YUV）</li>
<li>*&nbsp;Simplest&nbsp;Video&nbsp;Play&nbsp;GDI&nbsp;(GDI&nbsp;play&nbsp;RGB/YUV)</li>
<li>*</li>
<li>*&nbsp;雷霄骅&nbsp;Lei&nbsp;Xiaohua</li>
<li>*&nbsp;leixiaohua1020@126.com</li>
<li>*&nbsp;中国传媒大学/数字电视技术</li>
<li>*&nbsp;Communication&nbsp;University&nbsp;of&nbsp;China&nbsp;/&nbsp;Digital&nbsp;TV&nbsp;Technology</li>
<li>*&nbsp;http://blog.csdn.net/leixiaohua1020</li>
<li>*</li>
<li>*&nbsp;本程序使用GDI播放RGB/YUV视频像素数据。GDI实际上只能直接播放RGB数据。</li>
<li>*&nbsp;因此如果输入数据为YUV420P的话，需要先转换为RGB数据之后再进行播放。</li>
<li>*</li>
<li>*&nbsp;函数调用步骤如下：</li>
<li>*&nbsp;GetDC()：获得显示设备的句柄。</li>
<li>*&nbsp;像素数据格式的转换（如果需要的话）</li>
<li>*&nbsp;设置BMP文件头...</li>
<li>*&nbsp;StretchDIBits()：指定BMP文件头，以及像素数据，绘制。</li>
<li>*&nbsp;ReleaseDC()：释放显示设备的句柄。</li>
<li>*</li>
<li>*&nbsp;在该示例程序中，包含了像素转换的几个工具函数，以及&ldquo;大端&rdquo;，</li>
<li>*&nbsp;&ldquo;小端&rdquo;（字节顺序）相互转换的函数。</li>
<li>*</li>
<li>*&nbsp;This&nbsp;software&nbsp;plays&nbsp;RGB/YUV&nbsp;raw&nbsp;video&nbsp;data&nbsp;using&nbsp;GDI.</li>
<li>*&nbsp;In&nbsp;fact&nbsp;GDI&nbsp;only&nbsp;can&nbsp;draw&nbsp;RGB&nbsp;data.&nbsp;So&nbsp;If&nbsp;input&nbsp;data&nbsp;is</li>
<li>*&nbsp;YUV420P,&nbsp;it&nbsp;need&nbsp;to&nbsp;be&nbsp;convert&nbsp;to&nbsp;RGB&nbsp;first.</li>
<li>*&nbsp;It's&nbsp;the&nbsp;simplest&nbsp;GDI&nbsp;tutorial&nbsp;(About&nbsp;video&nbsp;playback).</li>
<li>*</li>
<li>*&nbsp;The&nbsp;process&nbsp;is&nbsp;shown&nbsp;as&nbsp;follows:</li>
<li>*</li>
<li>*&nbsp;GetDC()：retrieves&nbsp;a&nbsp;handle&nbsp;to&nbsp;a&nbsp;device&nbsp;context&nbsp;(DC).</li>
<li>*&nbsp;Convert&nbsp;pixel&nbsp;data&nbsp;format(if&nbsp;needed).</li>
<li>*&nbsp;Set&nbsp;BMP&nbsp;Header...</li>
<li>*&nbsp;StretchDIBits()：Set&nbsp;pixel&nbsp;data&nbsp;and&nbsp;BMP&nbsp;data&nbsp;and&nbsp;begin&nbsp;to&nbsp;draw.</li>
<li>*&nbsp;ReleaseDC()：release&nbsp;the&nbsp;handle.</li>
<li>*</li>
<li>*&nbsp;In&nbsp;this&nbsp;program&nbsp;there&nbsp;are&nbsp;some&nbsp;functions&nbsp;about&nbsp;conversion</li>
<li>*&nbsp;between&nbsp;pixel&nbsp;format&nbsp;and&nbsp;conversion&nbsp;between&nbsp;"Big&nbsp;Endian"&nbsp;and</li>
<li>*&nbsp;"Little&nbsp;Endian".</li>
<li>*/</li>
<li>#include&nbsp;&lt;stdio.h&gt;</li>
<li>#include&nbsp;&lt;tchar.h&gt;</li>
<li>#include&nbsp;&lt;Windows.h&gt;</li>
<li>//set&nbsp;'1'&nbsp;to&nbsp;choose&nbsp;a&nbsp;type&nbsp;of&nbsp;file&nbsp;to&nbsp;play</li>
<li>#define&nbsp;LOAD_BGRA&nbsp;&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_RGB24&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_BGR24&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_YUV420P&nbsp;1</li>
<li>//Width,&nbsp;Height</li>
<li>const&nbsp;int&nbsp;screen_w=500,screen_h=500;</li>
<li>const&nbsp;int&nbsp;pixel_w=320,pixel_h=180;</li>
<li>//Bit&nbsp;per&nbsp;Pixel</li>
<li>#if&nbsp;LOAD_BGRA</li>
<li>const&nbsp;int&nbsp;bpp=32;</li>
<li>#elif&nbsp;LOAD_RGB24|LOAD_BGR24</li>
<li>const&nbsp;int&nbsp;bpp=24;</li>
<li>#elif&nbsp;LOAD_YUV420P</li>
<li>const&nbsp;int&nbsp;bpp=12;</li>
<li>#endif</li>
<li>FILE&nbsp;*fp=NULL;</li>
<li>//Storage&nbsp;frame&nbsp;data</li>
<li>unsigned&nbsp;char&nbsp;buffer[pixel_w*pixel_h*bpp/8];</li>
<li>unsigned&nbsp;char&nbsp;buffer_convert[pixel_w*pixel_h*3];</li>
<li>//Not&nbsp;Efficient,&nbsp;Just&nbsp;an&nbsp;example</li>
<li>//change&nbsp;endian&nbsp;of&nbsp;a&nbsp;pixel&nbsp;(32bit)</li>
<li>void&nbsp;CHANGE_ENDIAN_32(unsigned&nbsp;char&nbsp;*data){</li>
<li>char&nbsp;temp3,temp2;</li>
<li>temp3=data[3];</li>
<li>temp2=data[2];</li>
<li>data[3]=data[0];</li>
<li>data[2]=data[1];</li>
<li>data[0]=temp3;</li>
<li>data[1]=temp2;</li>
<li>}</li>
<li>//change&nbsp;endian&nbsp;of&nbsp;a&nbsp;pixel&nbsp;(24bit)</li>
<li>void&nbsp;CHANGE_ENDIAN_24(unsigned&nbsp;char&nbsp;*data){</li>
<li>char&nbsp;temp2=data[2];</li>
<li>data[2]=data[0];</li>
<li>data[0]=temp2;</li>
<li>}</li>
<li>//RGBA&nbsp;to&nbsp;RGB24&nbsp;(or&nbsp;BGRA&nbsp;to&nbsp;BGR24)</li>
<li>void&nbsp;CONVERT_RGBA32toRGB24(unsigned&nbsp;char&nbsp;*image,int&nbsp;w,int&nbsp;h){</li>
<li>for(int&nbsp;i&nbsp;=0;i&lt;h;i++)</li>
<li>for(int&nbsp;j=0;j&lt;w;j++){</li>
<li>memcpy(image+(i*w+j)*3,image+(i*w+j)*4,3);</li>
<li>}</li>
<li>}</li>
<li>//RGB24&nbsp;to&nbsp;BGR24</li>
<li>void&nbsp;CONVERT_RGB24toBGR24(unsigned&nbsp;char&nbsp;*image,int&nbsp;w,int&nbsp;h){</li>
<li>for(int&nbsp;i&nbsp;=0;i&lt;h;i++)</li>
<li>for(int&nbsp;j=0;j&lt;w;j++){</li>
<li>char&nbsp;temp2;</li>
<li>temp2=image[(i*w+j)*3+2];</li>
<li>image[(i*w+j)*3+2]=image[(i*w+j)*3+0];</li>
<li>image[(i*w+j)*3+0]=temp2;</li>
<li>}</li>
<li>}</li>
<li>//Change&nbsp;endian&nbsp;of&nbsp;a&nbsp;picture</li>
<li>void&nbsp;CHANGE_ENDIAN_PIC(unsigned&nbsp;char&nbsp;*image,int&nbsp;w,int&nbsp;h,int&nbsp;bpp){</li>
<li>unsigned&nbsp;char&nbsp;*pixeldata=NULL;</li>
<li>for(int&nbsp;i&nbsp;=0;i&lt;h;i++)</li>
<li>for(int&nbsp;j=0;j&lt;w;j++){</li>
<li>pixeldata=image+(i*w+j)*bpp/8;</li>
<li>if(bpp==32){</li>
<li>CHANGE_ENDIAN_32(pixeldata);</li>
<li>}else&nbsp;if(bpp==24){</li>
<li>CHANGE_ENDIAN_24(pixeldata);</li>
<li>}</li>
<li>}</li>
<li>}</li>
<li>inline&nbsp;unsigned&nbsp;char&nbsp;CONVERT_ADJUST(double&nbsp;tmp)</li>
<li>{</li>
<li>return&nbsp;(unsigned&nbsp;char)((tmp&nbsp;&gt;=&nbsp;0&nbsp;&amp;&amp;&nbsp;tmp&nbsp;&lt;=&nbsp;255)?tmp:(tmp&nbsp;&lt;&nbsp;0&nbsp;?&nbsp;0&nbsp;:&nbsp;255));</li>
<li>}</li>
<li>//YUV420P&nbsp;to&nbsp;RGB24</li>
<li>void&nbsp;CONVERT_YUV420PtoRGB24(unsigned&nbsp;char*&nbsp;yuv_src,unsigned&nbsp;char*&nbsp;rgb_dst,int&nbsp;nWidth,int&nbsp;nHeight)</li>
<li>{</li>
<li>unsigned&nbsp;char&nbsp;*tmpbuf=(unsigned&nbsp;char&nbsp;*)malloc(nWidth*nHeight*3);</li>
<li>unsigned&nbsp;char&nbsp;Y,U,V,R,G,B;</li>
<li>unsigned&nbsp;char*&nbsp;y_planar,*u_planar,*v_planar;</li>
<li>int&nbsp;rgb_width&nbsp;,&nbsp;u_width;</li>
<li>rgb_width&nbsp;=&nbsp;nWidth&nbsp;*&nbsp;3;</li>
<li>u_width&nbsp;=&nbsp;(nWidth&nbsp;&gt;&gt;&nbsp;1);</li>
<li>int&nbsp;ypSize&nbsp;=&nbsp;nWidth&nbsp;*&nbsp;nHeight;</li>
<li>int&nbsp;upSize&nbsp;=&nbsp;(ypSize&gt;&gt;2);</li>
<li>int&nbsp;offSet&nbsp;=&nbsp;0;</li>
<li>y_planar&nbsp;=&nbsp;yuv_src;</li>
<li>u_planar&nbsp;=&nbsp;yuv_src&nbsp;+&nbsp;ypSize;</li>
<li>v_planar&nbsp;=&nbsp;u_planar&nbsp;+&nbsp;upSize;</li>
<li>for(int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;nHeight;&nbsp;i++)</li>
<li>{</li>
<li>for(int&nbsp;j&nbsp;=&nbsp;0;&nbsp;j&nbsp;&lt;&nbsp;nWidth;&nbsp;j&nbsp;++)</li>
<li>{</li>
<li>//&nbsp;Get&nbsp;the&nbsp;Y&nbsp;value&nbsp;from&nbsp;the&nbsp;y&nbsp;planar</li>
<li>Y&nbsp;=&nbsp;*(y_planar&nbsp;+&nbsp;nWidth&nbsp;*&nbsp;i&nbsp;+&nbsp;j);</li>
<li>//&nbsp;Get&nbsp;the&nbsp;V&nbsp;value&nbsp;from&nbsp;the&nbsp;u&nbsp;planar</li>
<li>offSet&nbsp;=&nbsp;(i&gt;&gt;1)&nbsp;*&nbsp;(u_width)&nbsp;+&nbsp;(j&gt;&gt;1);</li>
<li>V&nbsp;=&nbsp;*(u_planar&nbsp;+&nbsp;offSet);</li>
<li>//&nbsp;Get&nbsp;the&nbsp;U&nbsp;value&nbsp;from&nbsp;the&nbsp;v&nbsp;planar</li>
<li>U&nbsp;=&nbsp;*(v_planar&nbsp;+&nbsp;offSet);</li>
<li>//&nbsp;Cacular&nbsp;the&nbsp;R,G,B&nbsp;values</li>
<li>//&nbsp;Method&nbsp;1</li>
<li>R&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;+&nbsp;(1.4075&nbsp;*&nbsp;(V&nbsp;-&nbsp;128))));</li>
<li>G&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;-&nbsp;(0.3455&nbsp;*&nbsp;(U&nbsp;-&nbsp;128)&nbsp;-&nbsp;0.7169&nbsp;*&nbsp;(V&nbsp;-&nbsp;128))));</li>
<li>B&nbsp;=&nbsp;CONVERT_ADJUST((Y&nbsp;+&nbsp;(1.7790&nbsp;*&nbsp;(U&nbsp;-&nbsp;128))));</li>
<li>/*</li>
<li>//&nbsp;The&nbsp;following&nbsp;formulas&nbsp;are&nbsp;from&nbsp;MicroSoft'&nbsp;MSDN</li>
<li>int&nbsp;C,D,E;</li>
<li>//&nbsp;Method&nbsp;2</li>
<li>C&nbsp;=&nbsp;Y&nbsp;-&nbsp;16;</li>
<li>D&nbsp;=&nbsp;U&nbsp;-&nbsp;128;</li>
<li>E&nbsp;=&nbsp;V&nbsp;-&nbsp;128;</li>
<li>R&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;+&nbsp;409&nbsp;*&nbsp;E&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>G&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;-&nbsp;100&nbsp;*&nbsp;D&nbsp;-&nbsp;208&nbsp;*&nbsp;E&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>B&nbsp;=&nbsp;CONVERT_ADJUST((&nbsp;298&nbsp;*&nbsp;C&nbsp;+&nbsp;516&nbsp;*&nbsp;D&nbsp;+&nbsp;128)&nbsp;&gt;&gt;&nbsp;8);</li>
<li>R&nbsp;=&nbsp;((R&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(R&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>G&nbsp;=&nbsp;((G&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(G&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>B&nbsp;=&nbsp;((B&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128&nbsp;)&gt;255?255:(B&nbsp;-&nbsp;128)&nbsp;*&nbsp;.6&nbsp;+&nbsp;128;</li>
<li>*/</li>
<li>offSet&nbsp;=&nbsp;rgb_width&nbsp;*&nbsp;i&nbsp;+&nbsp;j&nbsp;*&nbsp;3;</li>
<li>rgb_dst[offSet]&nbsp;=&nbsp;B;</li>
<li>rgb_dst[offSet&nbsp;+&nbsp;1]&nbsp;=&nbsp;G;</li>
<li>rgb_dst[offSet&nbsp;+&nbsp;2]&nbsp;=&nbsp;R;</li>
<li>}</li>
<li>}</li>
<li>free(tmpbuf);</li>
<li>}</li>
<li>bool&nbsp;Render(HWND&nbsp;hwnd)</li>
<li>{</li>
<li>//Read&nbsp;Pixel&nbsp;Data</li>
<li>if&nbsp;(fread(buffer,&nbsp;1,&nbsp;pixel_w*pixel_h*bpp/8,&nbsp;fp)&nbsp;!=&nbsp;pixel_w*pixel_h*bpp/8){</li>
<li>//&nbsp;Loop</li>
<li>fseek(fp,&nbsp;0,&nbsp;SEEK_SET);</li>
<li>fread(buffer,&nbsp;1,&nbsp;pixel_w*pixel_h*bpp/8,&nbsp;fp);</li>
<li>}</li>
<li>HDC&nbsp;hdc=GetDC(hwnd);</li>
<li>//Note:</li>
<li>//Big&nbsp;Endian&nbsp;or&nbsp;Small&nbsp;Endian?</li>
<li>//ARGB&nbsp;order:high&nbsp;bit&nbsp;-&gt;&nbsp;low&nbsp;bit.</li>
<li>//ARGB&nbsp;Format&nbsp;Big&nbsp;Endian&nbsp;(low&nbsp;address&nbsp;save&nbsp;high&nbsp;MSB,&nbsp;here&nbsp;is&nbsp;A)&nbsp;in&nbsp;memory&nbsp;:&nbsp;A|R|G|B</li>
<li>//ARGB&nbsp;Format&nbsp;Little&nbsp;Endian&nbsp;(low&nbsp;address&nbsp;save&nbsp;low&nbsp;MSB,&nbsp;here&nbsp;is&nbsp;B)&nbsp;in&nbsp;memory&nbsp;:&nbsp;B|G|R|A</li>
<li>//Microsoft&nbsp;Windows&nbsp;is&nbsp;Little&nbsp;Endian</li>
<li>//So&nbsp;we&nbsp;must&nbsp;change&nbsp;the&nbsp;order</li>
<li>#if&nbsp;LOAD_BGRA</li>
<li>CONVERT_RGBA32toRGB24(buffer,pixel_w,pixel_h);</li>
<li>//we&nbsp;don't&nbsp;need&nbsp;to&nbsp;change&nbsp;endian</li>
<li>//Because&nbsp;input&nbsp;BGR24&nbsp;pixel&nbsp;data(B|G|R)&nbsp;is&nbsp;same&nbsp;as&nbsp;RGB&nbsp;in&nbsp;Little&nbsp;Endian&nbsp;(B|G|R)</li>
<li>#elif&nbsp;LOAD_RGB24</li>
<li>//Change&nbsp;to&nbsp;Little&nbsp;Endian</li>
<li>CHANGE_ENDIAN_PIC(buffer,pixel_w,pixel_h,24);</li>
<li>#elif&nbsp;LOAD_BGR24</li>
<li>//In&nbsp;fact&nbsp;we&nbsp;don't&nbsp;need&nbsp;to&nbsp;do&nbsp;anything.</li>
<li>//Because&nbsp;input&nbsp;BGR24&nbsp;pixel&nbsp;data(B|G|R)&nbsp;is&nbsp;same&nbsp;as&nbsp;RGB&nbsp;in&nbsp;Little&nbsp;Endian&nbsp;(B|G|R)</li>
<li>//CONVERT_RGB24toBGR24(buffer,pixel_w,pixel_h);</li>
<li>//CHANGE_ENDIAN_PIC(buffer,pixel_w,pixel_h,24);</li>
<li>#elif&nbsp;LOAD_YUV420P</li>
<li>//YUV&nbsp;Need&nbsp;to&nbsp;Convert&nbsp;to&nbsp;RGB&nbsp;first</li>
<li>//YUV420P&nbsp;to&nbsp;RGB24</li>
<li>CONVERT_YUV420PtoRGB24(buffer,buffer_convert,pixel_w,pixel_h);</li>
<li>//Change&nbsp;to&nbsp;Little&nbsp;Endian</li>
<li>CHANGE_ENDIAN_PIC(buffer_convert,pixel_w,pixel_h,24);</li>
<li>#endif</li>
<li>//BMP&nbsp;Header</li>
<li>BITMAPINFO&nbsp;m_bmphdr={0};</li>
<li>DWORD&nbsp;dwBmpHdr&nbsp;=&nbsp;sizeof(BITMAPINFO);</li>
<li>//24bit</li>
<li>m_bmphdr.bmiHeader.biBitCount&nbsp;=&nbsp;24;</li>
<li>m_bmphdr.bmiHeader.biClrImportant&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biSize&nbsp;=&nbsp;dwBmpHdr;</li>
<li>m_bmphdr.bmiHeader.biSizeImage&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biWidth&nbsp;=&nbsp;pixel_w;</li>
<li>//Notice:&nbsp;BMP&nbsp;storage&nbsp;pixel&nbsp;data&nbsp;in&nbsp;opposite&nbsp;direction&nbsp;of&nbsp;Y-axis&nbsp;(from&nbsp;bottom&nbsp;to&nbsp;top).</li>
<li>//So&nbsp;we&nbsp;must&nbsp;set&nbsp;reverse&nbsp;biHeight&nbsp;to&nbsp;show&nbsp;image&nbsp;correctly.</li>
<li>m_bmphdr.bmiHeader.biHeight&nbsp;=&nbsp;-pixel_h;</li>
<li>m_bmphdr.bmiHeader.biXPelsPerMeter&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biYPelsPerMeter&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biClrUsed&nbsp;=&nbsp;0;</li>
<li>m_bmphdr.bmiHeader.biPlanes&nbsp;=&nbsp;1;</li>
<li>m_bmphdr.bmiHeader.biCompression&nbsp;=&nbsp;BI_RGB;</li>
<li>//Draw&nbsp;data</li>
<li>#if&nbsp;LOAD_YUV420P</li>
<li>//YUV420P&nbsp;data&nbsp;convert&nbsp;to&nbsp;another&nbsp;buffer</li>
<li>int&nbsp;nResult&nbsp;=&nbsp;StretchDIBits(hdc,</li>
<li>0,0,</li>
<li>screen_w,screen_h,</li>
<li>0,&nbsp;0,</li>
<li>pixel_w,&nbsp;pixel_h,</li>
<li>buffer_convert,</li>
<li>&amp;m_bmphdr,</li>
<li>DIB_RGB_COLORS,</li>
<li>SRCCOPY);</li>
<li>#else</li>
<li>//Draw&nbsp;data</li>
<li>int&nbsp;nResult&nbsp;=&nbsp;StretchDIBits(hdc,</li>
<li>0,0,</li>
<li>screen_w,screen_h,</li>
<li>0,&nbsp;0,</li>
<li>pixel_w,&nbsp;pixel_h,</li>
<li>buffer,</li>
<li>&amp;m_bmphdr,</li>
<li>DIB_RGB_COLORS,</li>
<li>SRCCOPY);</li>
<li>#endif</li>
<li>ReleaseDC(hwnd,hdc);</li>
<li>return&nbsp;true;</li>
<li>}</li>
<li>LRESULT&nbsp;WINAPI&nbsp;MyWndProc(HWND&nbsp;hwnd,&nbsp;UINT&nbsp;msg,&nbsp;WPARAM&nbsp;wparma,&nbsp;LPARAM&nbsp;lparam)</li>
<li>{</li>
<li>switch(msg){</li>
<li>case&nbsp;WM_DESTROY:</li>
<li>PostQuitMessage(0);</li>
<li>return&nbsp;0;</li>
<li>}</li>
<li>return&nbsp;DefWindowProc(hwnd,&nbsp;msg,&nbsp;wparma,&nbsp;lparam);</li>
<li>}</li>
<li>int&nbsp;WINAPI&nbsp;WinMain(&nbsp;__in&nbsp;HINSTANCE&nbsp;hInstance,&nbsp;__in_opt&nbsp;HINSTANCE&nbsp;hPrevInstance,&nbsp;__in&nbsp;LPSTR&nbsp;lpCmdLine,&nbsp;__in&nbsp;int&nbsp;nShowCmd&nbsp;)</li>
<li>{</li>
<li>WNDCLASSEX&nbsp;wc;</li>
<li>ZeroMemory(&amp;wc,&nbsp;sizeof(wc));</li>
<li>wc.cbSize&nbsp;=&nbsp;sizeof(wc);</li>
<li>wc.hbrBackground&nbsp;=&nbsp;(HBRUSH)(COLOR_WINDOW&nbsp;+&nbsp;1);</li>
<li>wc.lpfnWndProc&nbsp;=&nbsp;(WNDPROC)MyWndProc;</li>
<li>wc.lpszClassName&nbsp;=&nbsp;_T("GDI");</li>
<li>wc.style&nbsp;=&nbsp;CS_HREDRAW&nbsp;|&nbsp;CS_VREDRAW;</li>
<li>RegisterClassEx(&amp;wc);</li>
<li>HWND&nbsp;hwnd&nbsp;=&nbsp;NULL;</li>
<li>hwnd&nbsp;=&nbsp;CreateWindow(_T("GDI"),&nbsp;_T("Simplest&nbsp;Video&nbsp;Play&nbsp;GDI"),&nbsp;WS_OVERLAPPEDWINDOW,&nbsp;100,&nbsp;100,&nbsp;500,&nbsp;500,&nbsp;NULL,&nbsp;NULL,&nbsp;hInstance,&nbsp;NULL);</li>
<li>if&nbsp;(hwnd==NULL){</li>
<li>return&nbsp;-1;</li>
<li>}</li>
<li>ShowWindow(hwnd,&nbsp;nShowCmd);</li>
<li>UpdateWindow(hwnd);</li>
<li>#if&nbsp;LOAD_BGRA</li>
<li>fp=fopen("../test_bgra_320x180.rgb","rb+");</li>
<li>#elif&nbsp;LOAD_RGB24</li>
<li>fp=fopen("../test_rgb24_320x180.rgb","rb+");</li>
<li>#elif&nbsp;LOAD_BGR24</li>
<li>fp=fopen("../test_bgr24_320x180.rgb","rb+");</li>
<li>#elif&nbsp;LOAD_YUV420P</li>
<li>fp=fopen("../test_yuv420p_320x180.yuv","rb+");</li>
<li>#endif</li>
<li>if(fp==NULL){</li>
<li>printf("Cannot&nbsp;open&nbsp;this&nbsp;file.\n");</li>
<li>return&nbsp;-1;</li>
<li>}</li>
<li>MSG&nbsp;msg;</li>
<li>ZeroMemory(&amp;msg,&nbsp;sizeof(msg));</li>
<li>while&nbsp;(msg.message&nbsp;!=&nbsp;WM_QUIT){</li>
<li>//PeekMessage()&nbsp;is&nbsp;not&nbsp;same&nbsp;as&nbsp;GetMessage</li>
<li>if&nbsp;(PeekMessage(&amp;msg,&nbsp;NULL,&nbsp;0,&nbsp;0,&nbsp;PM_REMOVE)){</li>
<li>TranslateMessage(&amp;msg);</li>
<li>DispatchMessage(&amp;msg);</li>
<li>}</li>
<li>else{</li>
<li>Sleep(40);</li>
<li>Render(hwnd);</li>
<li>}</li>
<li>}</li>
<li>UnregisterClass(_T("GDI"),&nbsp;hInstance);</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
<h3>代码注意事项</h3>
<p>1.可以通过设置定义在文件开始出的宏，决定读取哪个格式的像素数据（bgra，rgb24，bgr24，yuv420p）。</p>
<div>
<ol><li>//set&nbsp;'1'&nbsp;to&nbsp;choose&nbsp;a&nbsp;type&nbsp;of&nbsp;file&nbsp;to&nbsp;play</li>
<li>#define&nbsp;LOAD_BGRA&nbsp;&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_RGB24&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_BGR24&nbsp;&nbsp;&nbsp;0</li>
<li>#define&nbsp;LOAD_YUV420P&nbsp;1</li></ol>
</div>
<p>2.窗口的宽高为screen_w，screen_h。像素数据的宽高为pixel_w,pixel_h。它们的定义如下。</p>
<div>
<ol><li>//Width,&nbsp;Height</li>
<li>const&nbsp;int&nbsp;screen_w=500,screen_h=500;</li>
<li>const&nbsp;int&nbsp;pixel_w=320,pixel_h=180;</li></ol>
</div>
<h3>程序流程图</h3>
<p>程序的流程图可以简单概括如下所示。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019200723168?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<h2>结果</h2>
<p>不论选择读取哪个格式的文件，程序的最终输出效果都是一样的，如下图所示。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141019200941088?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGVpeGlhb2h1YTEwMjA=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<h2>下载</h2>
<p>代码位于&ldquo;Simplest Media Play&rdquo;中</p>
<p>SourceForge项目地址：<a href="https://sourceforge.net/projects/simplestmediaplay/" rel="external nofollow noreferrer">https://sourceforge.net/projects/simplestmediaplay/</a></p>
<p>CSDN下载地址：<a href="http://download.csdn.net/detail/leixiaohua1020/8054395" rel="external nofollow noreferrer">http://download.csdn.net/detail/leixiaohua1020/8054395</a></p>
<p>上述工程包含了使用各种API（Direct3D，OpenGL，GDI，DirectSound，SDL2）播放多媒体例子。其中音频输入为PCM采样数据。输出至系统的声卡播放出来。视频输入为YUV/RGB像素数据。输出至显示器上的一个窗口播放出来。</p>
<p>通过本工程的代码初学者可以快速学习使用这几个API播放视频和音频的技术。</p>
<p>一共包括了如下几个子工程：</p>
<p>simplest_audio_play_directsound:&nbsp;	使用DirectSound播放PCM音频采样数据。<br />simplest_audio_play_sdl2:&nbsp;			使用SDL2播放PCM音频采样数据。<br />simplest_video_play_direct3d:&nbsp;		使用Direct3D的Surface播放RGB/YUV视频像素数据。<br />simplest_video_play_direct3d_texture:	使用Direct3D的Texture播放RGB视频像素数据。<br />simplest_video_play_gdi:&nbsp;				使用GDI播放RGB/YUV视频像素数据。<br />simplest_video_play_opengl:&nbsp;			使用OpenGL播放RGB/YUV视频像素数据。<br />simplest_video_play_opengl_texture:	使用OpenGL的Texture播放YUV视频像素数据。<br />simplest_video_play_sdl2:&nbsp;			使用SDL2播放RGB/YUV视频像素数据。</p>
<p>from:http://blog.csdn.net/leixiaohua1020/article/details/40266503</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy32j8r.html">&period;NET Core 使用Dapper 操作MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8md72p8.html">win10中将默认输入法设置为英文</a>
		</li>
						<li><a href="https://www.batexi.com/a/390xlj39.html">Android 优化List图片显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jo1zgq.html">树莓派3 Windows 10 IoT Core</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndezv8.html">C语言每日一题之No&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwmpoq.html">windows下eclipse&plus;hadoop2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpgeoq.html">js中return；、return true、return false&semi;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okx2ke9.html">MySQL Mysqlslap</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x02g09.html">hibernate通过配置文件生成数据库信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnxgl8.html">MySQL如何正确查询字段为NULL的字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6gdr9.html">SpringMVC&lpar;十一&rpar;：SpringMVC 处理输出模型数据之SessionAttributes</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj63z69.html">201771010118 马昕璐 《面向对象设计 java》第十七周实验总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2w1wrq.html">extjs ajax 同步 及 confirm 确认提示框问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kojj9.html">A1086&period; Tree Traversals Again</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rnww39.html">Journal of BitcoinJ 从clone开始</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pp3pq.html">idea 自动导入包 快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4prez9.html">win2d 图片水印</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kom545q.html">Jdk1&period;8在CentOS7中的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p4dz5q.html">sql server性能查询&comma;连接数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvew7v19.html">git使用多个SSH公钥信息</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmkkv19.html">TesserOCR训练</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdezzxj9.html">check environment var</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd50nxq.html">枚举&vert;标志枚举&plus;&vert;&lpar;或&rpar;和&amp;amp&semi;&lpar;与&rpar;运算&vert;类型转换&vert;值类型和引用类型&vert;传参&vert;异常&vert;垃圾回收</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyzxy9.html">crontab 指定执行用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1vd6r9.html">jmeter 使用聚合报告分析jtl文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd5xjxq.html">lintcode： search for a range 搜索区间</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ykwonq.html">lintcode&colon; 二叉查找树中搜索区间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdez3309.html">Debug过程中的mock （及display窗口的使用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okgw6e9.html">jvm调优具体参数配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1yemg8.html">C&num;基础练习（时间的三连击）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
